Package org.apache.sling.jcr.base.spi

## Interface RepositoryMount

All Superinterfaces:
  `org.apache.jackrabbit.api.JackrabbitRepository`, `javax.jcr.Repository`

    public interface RepositoryMount
    extends org.apache.jackrabbit.api.JackrabbitRepository

A `RepositoryMount` works similar to a resource provider and allows to connect custom data. But it works on the lower JCR API level. This way legacy code using JCR API can be supported as well. However, implementors of this interface need to implement the full JCR API - which is more complex than the resource provider. Therefore a repository mount should only be used for special cases where legacy code using JCR API is used.

The JCR base implementation supports only a single `RepositoryMount`. In case of several registrations, the one with the highest service ranking will be used.

The `RepositoryMount` must implement `JackrabbitRepository.login(javax.jcr.Credentials, String, java.util.Map)` in order to login against the custom data provider. It will get access to the JCR session through `PARENT_SESSION_KEY`.

### Field Summary

Fields
`static String` `MOUNT_POINTS_KEY` The repository needs to register itself with this property which is a String+ property defining the paths in the JCR tree where the handling of the nodes is delegated to the mounter.
`static String` `PARENT_SESSION_KEY` The key of the attribute holding the parent session when `JackrabbitRepository.login(javax.jcr.Credentials, String, java.util.Map)` is called.

### Fields inherited from interface org.apache.jackrabbit.api.JackrabbitRepository

`OPTION_PRINCIPAL_MANAGEMENT_SUPPORTED, OPTION_PRIVILEGE_MANAGEMENT_SUPPORTED, OPTION_USER_MANAGEMENT_SUPPORTED`

### Fields inherited from interface javax.jcr.Repository

`IDENTIFIER_STABILITY, IDENTIFIER_STABILITY_INDEFINITE_DURATION, IDENTIFIER_STABILITY_METHOD_DURATION, IDENTIFIER_STABILITY_SAVE_DURATION, IDENTIFIER_STABILITY_SESSION_DURATION, LEVEL_1_SUPPORTED, LEVEL_2_SUPPORTED, NODE_TYPE_MANAGEMENT_AUTOCREATED_DEFINITIONS_SUPPORTED, NODE_TYPE_MANAGEMENT_INHERITANCE, NODE_TYPE_MANAGEMENT_INHERITANCE_MINIMAL, NODE_TYPE_MANAGEMENT_INHERITANCE_MULTIPLE, NODE_TYPE_MANAGEMENT_INHERITANCE_SINGLE, NODE_TYPE_MANAGEMENT_MULTIPLE_BINARY_PROPERTIES_SUPPORTED, NODE_TYPE_MANAGEMENT_MULTIVALUED_PROPERTIES_SUPPORTED, NODE_TYPE_MANAGEMENT_ORDERABLE_CHILD_NODES_SUPPORTED, NODE_TYPE_MANAGEMENT_OVERRIDES_SUPPORTED, NODE_TYPE_MANAGEMENT_PRIMARY_ITEM_NAME_SUPPORTED, NODE_TYPE_MANAGEMENT_PROPERTY_TYPES, NODE_TYPE_MANAGEMENT_RESIDUAL_DEFINITIONS_SUPPORTED, NODE_TYPE_MANAGEMENT_SAME_NAME_SIBLINGS_SUPPORTED, NODE_TYPE_MANAGEMENT_UPDATE_IN_USE_SUPORTED, NODE_TYPE_MANAGEMENT_VALUE_CONSTRAINTS_SUPPORTED, OPTION_ACCESS_CONTROL_SUPPORTED, OPTION_ACTIVITIES_SUPPORTED, OPTION_BASELINES_SUPPORTED, OPTION_JOURNALED_OBSERVATION_SUPPORTED, OPTION_LIFECYCLE_SUPPORTED, OPTION_LOCKING_SUPPORTED, OPTION_NODE_AND_PROPERTY_WITH_SAME_NAME_SUPPORTED, OPTION_NODE_TYPE_MANAGEMENT_SUPPORTED, OPTION_OBSERVATION_SUPPORTED, OPTION_QUERY_SQL_SUPPORTED, OPTION_RETENTION_SUPPORTED, OPTION_SHAREABLE_NODES_SUPPORTED, OPTION_SIMPLE_VERSIONING_SUPPORTED, OPTION_TRANSACTIONS_SUPPORTED, OPTION_UNFILED_CONTENT_SUPPORTED, OPTION_UPDATE_MIXIN_NODE_TYPES_SUPPORTED, OPTION_UPDATE_PRIMARY_NODE_TYPE_SUPPORTED, OPTION_VERSIONING_SUPPORTED, OPTION_WORKSPACE_MANAGEMENT_SUPPORTED, OPTION_XML_EXPORT_SUPPORTED, OPTION_XML_IMPORT_SUPPORTED, QUERY_FULL_TEXT_SEARCH_SUPPORTED, QUERY_JOINS, QUERY_JOINS_INNER, QUERY_JOINS_INNER_OUTER, QUERY_JOINS_NONE, QUERY_LANGUAGES, QUERY_STORED_QUERIES_SUPPORTED, QUERY_XPATH_DOC_ORDER, QUERY_XPATH_POS_INDEX, REP_NAME_DESC, REP_VENDOR_DESC, REP_VENDOR_URL_DESC, REP_VERSION_DESC, SPEC_NAME_DESC, SPEC_VERSION_DESC, WRITE_SUPPORTED`

### Method Summary

### Methods inherited from interface org.apache.jackrabbit.api.JackrabbitRepository

`login, shutdown`

### Methods inherited from interface javax.jcr.Repository

`getDescriptor, getDescriptorKeys, getDescriptorValue, getDescriptorValues, isSingleValueDescriptor, isStandardDescriptor, login, login, login, login`

### Field Detail

#### PARENT_SESSION_KEY

    static final String PARENT_SESSION_KEY

The key of the attribute holding the parent session when `JackrabbitRepository.login(javax.jcr.Credentials, String, java.util.Map)` is called.

See Also:
  Constant Field Values

#### MOUNT_POINTS_KEY

    static final String MOUNT_POINTS_KEY

The repository needs to register itself with this property which is a String+ property defining the paths in the JCR tree where the handling of the nodes is delegated to the mounter. The mounter can mount itself at various points in the JCR repository.

See Also:
  Constant Field Values